using System;
using System.IO;
using System.Xml;
using System.Threading;
using System.Resources;
using System.Collections;
using System.Globalization;

namespace LocalizationResxPatcher {
	class Patcher {
		[STAThread]
		static void Main(string[] args) {
			Thread.CurrentThread.CurrentCulture = CultureInfo.InvariantCulture;
			Patcher p = new Patcher();
			p.Run(args);
		}
		public void Run(string[] args) {
			string path;
			if(args.Length > 0)
				path = args[0];
			else {
				Console.WriteLine("Processing all project files in the current directory");
				path = Directory.GetCurrentDirectory();
			}
			DirectoryInfo root = new DirectoryInfo(path);
			if(root == null) return;
			ProcessDirectoryFiles(root);
			Console.WriteLine("Done.");
		}
		
		const string FindString = "SchemaVersion = \"1.0\"";
		const string ReplaceString = "SchemaVersion = \"2.0\"";
		const string FindString2 = "SchemaVersion=\"1.0\"";
		const string ReplaceString2 = "SchemaVersion=\"2.0\"";

		void ProcessProj(string file) {
			Console.Write("{0}\t", Path.GetFileName(file));
			try {
				string content = string.Empty;
				using(StreamReader sr = new StreamReader(file)) {
					content = sr.ReadToEnd();
				}
				string patched = content.Replace(FindString, ReplaceString);
				if(patched == content)
					patched = content.Replace(FindString2, ReplaceString2);
				if(patched != content) {
					FileAttributes attr = File.GetAttributes(file);
					if((attr & FileAttributes.ReadOnly) == FileAttributes.ReadOnly)
                        File.SetAttributes(file, attr & ~FileAttributes.ReadOnly);
					using(StreamWriter sw = new StreamWriter(file)) {
						sw.Write(patched);
					}
					Console.WriteLine("Patched.");
				}
				else
					Console.WriteLine("Skipped.");
			}
			catch {
				Console.WriteLine("Failed!");
			}
		}
		private void ProcessDirectoryFiles(DirectoryInfo dir) {
			foreach(FileInfo file in dir.GetFiles("*.csproj"))
				ProcessProj(file.FullName);
			foreach(DirectoryInfo subdir in dir.GetDirectories())
				ProcessDirectoryFiles(subdir);
		}
	}
}
